#include <iostream>
using namespace std;

int binarySearch(int *A, int n, int x);

bool fastSorted2SumA(int *A,int n, int t, int & x,int &y); 
bool fastSorted2SumB(int *A,int n, int t, int & x,int &y); 

int main()
{

	// Test program 
	////////////////////////////////////////////////////////////
	int A[] = {-20,-10,3,5,7,9,10,12,13,20,22,50,70};
	int n = 13;
	cout<<"A: ";
	for(int i=0;i<n;i++) cout<<A[i]<<" ";
	cout<<endl;



	while(true) {
		cout<<"Enter t:";
		int t;
		cin>>t;
		if(!cin) return 0;

		int x,y;


		cout<<"part (a) ";
		bool foundA = fastSorted2SumA(A,n,t,x,y);
		if(foundA) cout<<"("<<x<<","<<y<<")";
		else cout<<"Not found";
		cout<<endl<<"part (b) ";
		bool foundB = fastSorted2SumB(A,n,t,x,y);
		if(foundB) cout<<"("<<x<<","<<y<<")";
		else cout<<"Not found";
		cout<<endl;


    }

	return 0;
	
	/////// End of test program /////////////////////////////////
}





bool fastSorted2SumA(int *A,int n, int t, int & x,int &y)
{
	for(int i=0;i<n;i++) {
		int j = binarySearch(A,n,t-A[i]);
        if(j!=-1) {
			x = A[i];
			y = A[j];
			return true;
		}
	}
	return false;
}



bool fastSorted2SumB(int *A,int n, int t, int & x,int &y)
{

	int i = 0;
	int j = n-1;
	while(i<=j) {
		if(A[i]+A[j]==t)  {
			x = A[i];
			y = A[j];
			return true;
		}
		else if(A[i]+A[j]>t)  
			j--;
		else // if A[i]+A[j]<t
			i++;
	}
	return false;
}


int binarySearch(int *A, int n, int x)
{
	int start = 0;
	int end = n-1;
	while(start <=end) {
		int mid = (start + end) / 2;
		if (x < A[mid])
			end = mid - 1;
		else if (x > A[mid])
			start = mid + 1;
		else //if x == A[mid]
			return mid;
	}
	return -1; 
}








